/* Volatile.h */

#ifndef VOLATILE_H
#define VOLATILE_H

/*---- INCLUDE FILES --------------------------------------------------------------------------------------*/
#include "CommonInclude.h"

/*---- TYPEDEFS -------------------------------------------------------------------------------------------*/

/* Volatile Namespace */
typedef struct {
  real_T mh_Error_LED_new;
  real_T mh_Forward_LED_new;
  real_T mh_Park_LED_new;
  real_T mh_Reverse_LED_new;
  real_T mh_Vehicle_Key;
  real_T mh_Vehicle_Ready_LED_new;
  uint32_T mh_CAN_1_std_handled_count;
  uint32_T mh_CAN_1_std_last_unhandled_id;
  uint32_T mh_CAN_1_std_receive_count;
  int16_T mh_init_resource_AN1M;
  int16_T mh_init_resource_AN2M;
  int16_T mh_init_resource_AN4M;
  int16_T mh_init_resource_AN5M;
  int16_T mh_init_resource_AN6M;
  int16_T mh_init_resource_ECUP;
  int16_T mh_init_resource_FUELP;
  int16_T mh_init_resource_INJ1D;
  int16_T mh_init_resource_INJ2D;
  int16_T mh_init_resource_INJ3D;
  int16_T mh_init_resource_MPRD;
  int16_T mh_init_resource_TACH;
  boolean_T mh_Error_LED_ovr;
  boolean_T mh_Forward_LED_ovr;
  boolean_T mh_MPRD;
  boolean_T mh_MPRD_KeepAlive;
  boolean_T mh_MPRD_new;
  boolean_T mh_MPRD_ovr;
  boolean_T mh_Park_LED_ovr;
  boolean_T mh_ProcessorReboot;
  boolean_T mh_RestoreNVFactoryDefaults;
  boolean_T mh_Reverse_LED_ovr;
  boolean_T mh_StoreNV;
  boolean_T mh_Vehicle_Ready_LED_ovr;
} Volatile_T;

/*---- RAM VARIABLES --------------------------------------------------------------------------------------*/
extern Volatile_T VolatileWork;

/*---- END OF FILE ----------------------------------------------------------------------------------------*/
#endif
